#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef double ld;
#define all(a) a.begin(), a.end()

struct point {
    ld x, y;

    point(ld x1, ld y1) {
        x = x1;
        y = y1;
    }

    point() {
        x = 0;
        y = 0;
    }
};

point pl(point a, point b) {
    return {a.x + b.x, a.y + b.y};
}

point mn(point a, point b) {
    return {a.x - b.x, a.y - b.y};
}

point pr(point a, point b) {
    return {a.x * b.x, a.y * b.y};
}

bool eq(point a, point b) {
    return (a.x == b.x && a.y == b.y);
}

ld scal(point a, point b) {
    return a.x * a.y + b.x * b.y;
}

ld dist(point a, point b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

ld ang(point a, point b) {
    ld an1 = acos(abs(a.x) / sqrt(a.x * a.x + a.y * a.y)) / M_PI * 180;
    if (a.x < 0 && a.y > 0)
        an1 = 180 - an1;
    if (a.x < 0 && a.y <= 0)
        an1 += 180;
    if (a.x >= 0 && a.y < 0)
        an1 = 360 - an1;
    //if()
    ld an2 = acos(abs(b.x) / sqrt(b.x * b.x + b.y * b.y)) / M_PI * 180;
    if (b.x < 0 && b.y > 0)
        an2 = 180 - an2;
    if (b.x < 0 && b.y <= 0)
        an2 += 180;
    if (b.x >= 0 && b.y < 0)
        an2 = 360 - an2;
    return abs(an1 - an2);
}

bool ok(vector<point> a, vector<point> b, vector<point> c, vector<point> d) {
    if (dist(a[0], a[1]) != dist(b[0], b[2]) || dist(a[0], a[2]) != dist(c[0], c[1]) ||
        dist(a[1], a[2]) != dist(d[1], d[2]))
        return false;
    ld a0 = ang(mn(a[1], a[0]), mn(a[2], a[0]));
    ld a1 = ang(mn(a[0], a[1]), mn(a[2], a[1]));
    ld a2 = ang(mn(a[0], a[2]), mn(a[1], a[2]));
    ld b0 = ang(mn(b[1], b[0]), mn(b[2], b[0])), b2 = ang(mn(b[0], b[2]), mn(b[1], b[2]));
    ld c0 = ang(mn(c[1], c[0]), mn(c[2], c[0])), c1 = ang(mn(c[0], c[1]), mn(c[2], c[1]));
    ld d1 = ang(mn(d[0], d[1]), mn(d[2], d[1])), d2 = ang(mn(d[0], d[2]), mn(d[1], d[2]));
    if (b0 + a0 + c0 != 180 || b2 + a1 + d2 != 180 || c1 + a2 + d1 != 180)
        return false;
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll test;
    cin >> test;
    ll n, i, j, k, o;
    cin >> n;
    vector<vector<point>> a(n);
    for (i = 0; i < n; i++)
        for (j = 0; j < 3; j++) {
            point p;
            cin >> p.x >> p.y;
            a[i].push_back(p);
        }
    set<vector<ll>> ans;
    for (i = 0; i < n; i++)
        for (j = 0; j < n; j++)
            if (j != i)
                for (k = 0; k < n; k++)
                    if (k != i && k != j)
                        for (o = 0; o < n; o++)
                            if (o != i && o != j && o != k) {
                                ll x1 = 3, t = 0;
                                while (x1--) {
                                    ll x2 = 3;
                                    while (x2--) {
                                        ll x3 = 3;
                                        while (x3--) {
                                            ll x4 = 3;
                                            while (x4--) {
                                                if (ok(a[i], a[j], a[k], a[o]))
                                                    t = 1;
                                                a[o].insert(a[o].begin(), a[o].back());
                                                a[o].pop_back();
                                            }
                                            a[k].insert(a[k].begin(), a[k].back());
                                            a[k].pop_back();
                                        }
                                        a[j].insert(a[j].begin(), a[j].back());
                                        a[j].pop_back();
                                    }
                                    a[i].insert(a[i].begin(), a[i].back());
                                    a[i].pop_back();
                                }
                                if (t) {
                                    vector<ll> pr = {i + 1, j + 1, k + 1, o + 1};
                                    sort(all(pr));
                                    ans.insert(pr);
                                }
                            }
    cout << ans.size() << '\n';
    for (auto it: ans) {
        for (auto jt: it)
            cout << jt << ' ';
        cout << '\n';
    }
}